
m3d=3+0.4;
m3r=m3d/2;

m4d=4+0.4;
m4r=m4d/2;

m5d=5+0.4;
m5r=m5d/2;

m3nd = 6.2+0.4;
m3nr = m3nd/2;
m3nh=2.8;

m5nd = 9+0.3;
m5nr = m5nd/2;
m5nh=4;

m6d=5.9+0.4;

m6nd=11.4+0.4;
m6nh=5;

m8d=7.8+0.3;
m8dh=m8d-0.1;
m8nd=14.5+0.3;
m8nh=6.5;


sbd = 8+0.3;
sbr = sbd/2;

iy=30.5-1.8-6.5;

hz=70;
hy=20;
hs=50;

td=m8d;		// !!!
tnd=m8nd;	// !!!
tnh=m8nh;	// !!!

dz=30; 		// beetween smooth and thread rod

bearing_diameter=15;

thinwall = 2;
bearing_size = bearing_diameter + 2 * thinwall;

hx=dz+tnd/2+bearing_size/2+2;

difference() {
	union() {
		translate([0,0,hz/2]) cube([hx, hy, hz], center=true);
		translate([hx/2-bearing_size/2, -15, 0]) cylinder(h = hz, r=bearing_size/2, $fn = 64);
		translate([hx/2-bearing_size, -15, 0]) cube([bearing_size, bearing_size/2, hz]);
		translate([-hx/2, -hy/2-(td+4), hz/2-(tnh+4)/2]) cube([hx-bearing_size/2, td+4, (tnh+4)]);
	} //union


	translate([hx/2-bearing_size/2, -15, -1]) cylinder(h = hz+2, r=bearing_diameter/2, $fn = 64);
	translate([hx/2-bearing_size/2,-15,-1]) rotate([0,0,-30])  cube([10,1,hz+2]);


	translate([hx/2-bearing_size/2-dz, -15, hz/2-tnh/2]) rotate([0,0,30]) cylinder(tnh, tnd/2, tnd/2, $fn=6);
	translate([hx/2-bearing_size/2-dz, -15-4, hz/2-tnh/2]) rotate([0,0,30]) cylinder(tnh, tnd/2, tnd/2, $fn=6);

	translate([hx/2-bearing_size/2-dz, -15, hz/2+tnh/2+0.2]) cylinder(4, (td+0.4)/2, (td+0.4)/2);
	translate([hx/2-bearing_size/2-dz, -15, hz/2-(tnh+4)/2+0.2]) cylinder((tnh+4)/2, (td+0.4)/2, (td+0.4)/2);




	translate([hx/2-bearing_size/2-dz/2, -hy/2-td-4-1, hz/2]) rotate([-90,0,0]) cylinder(hy+td+4+2, m4r, m4r, $fn=8);


	translate([-hx/2-1, 0, (hz-hs)/2]) rotate([0,90,0]) cylinder(hx+2, sbr, sbr, $fn=16);
	translate([-hx/2-1, 0, (hz-hs)/2+2.3]) rotate([0,90,0]) rotate([0,0,180]) cylinder(hx+2, sbd/3, sbd/3, $fn=5);
	translate([-hx/2-1, 0, (hz-hs)/2+hs]) rotate([0,90,0]) cylinder(hx+2, sbr, sbr, $fn=16);
	translate([-hx/2-1, 0, (hz-hs)/2+hs+2.3]) rotate([0,90,0]) rotate([0,0,180]) cylinder(hx+2, sbd/3, sbd/3, $fn=5
);

//	translate([-hx/2-1, -11.6/2, hz/2-20/2]) cube([5, 11.6, 20]);
	translate([-hx/2-1, -11.6/2, hz/2-20/2]) cube([hx+2, 11.6, 20]);
//	translate([-hx/2+5, -11.6/2, hz/2]) rotate([-90,0,0]) cylinder(11.6, 10,10);

	translate([-13/2-3, 0, -0.1]) cube([13, hy/2+0.1, (hz-hs)+0.1]);
	translate([-13/2-3, 0, hs]) cube([13, hy/2+0.1, (hz-hs)+0.1]);

   translate([-3, 1, (hz-hs)/2-4-2.5]) rotate([90,0,0]) cylinder(hy/2+2, m3r, m3r, $fn=8);
   translate([-3, 1, (hz-hs)/2+4+2.5]) rotate([90,0,0]) cylinder(hy/2+2, m3r, m3r, $fn=8);

   translate([-3, 1, (hz-hs)/2+hs-4-2.5]) rotate([90,0,0]) cylinder(hy/2+2, m3r, m3r, $fn=8);
   translate([-3, 1, (hz-hs)/2+hs+4+2.5]) rotate([90,0,0]) cylinder(hy/2+2, m3r, m3r, $fn=8);

   translate([-3, -hy/2+2, (hz-hs)/2-4-2.5]) rotate([90,0,0]) cylinder(3, 3.8, 3.8, $fn=16);
   translate([-3, -hy/2+2, (hz-hs)/2+4+2.5]) rotate([90,0,0]) cylinder(3, 3.8, 3.8, $fn=16);
   translate([-3, -hy/2+2, (hz-hs)/2+hs-4-2.5]) rotate([90,0,0]) cylinder(3, 3.8, 3.8, $fn=16);
   translate([-3, -hy/2+2, (hz-hs)/2+hs+4+2.5]) rotate([90,0,0]) cylinder(3, 3.8, 3.8, $fn=16);



} //  difference


//difference() {
//  translate([-hx/2, -hy/2-(td+4), 0]) cube([hx-bearing_size-0.5, (td+4)-0.5, hz/2-(tnh+4)/2-0.4]);
//  translate([-hx/2+1-0.1, -hy/2-(td+4)+1-0.1, 0]) cube([hx-bearing_size-0.5-2+0.2, (td+4)-0.5-2+0.2, hz/2-(tnh+4)/2-0.4-1]);
//}

//difference() {
//	translate([-13/2-3+0.5, 0.5, -0.1]) cube([13-1, hy/2-0.5, (hz-hs)-0.2]);
//	translate([-13/2-3+0.5+1, 0.5+1, -0.1]) cube([13-1-2, hy/2-0.5-2, (hz-hs)-0.2-1]);
//}

//translate([0, -2, hz/2]) cube([hx, 0.4, 20], center=true);
//translate([0, +2, hz/2]) cube([hx, 0.4, 20], center=true);


