
m3d=3+0.4;
m3r=m3d/2;

m4d=4+0.4;
m4r=m4d/2;

m5d=5+0.4;
m5r=m5d/2;

m3nd = 6.2+0.4;
m3nr = m3nd/2;
m3nh=2.8;

m5nd = 9+0.3;
m5nr = m5nd/2;
m5nh=4;

m6d=5.9+0.4;

m6nd=11.4+0.4;
m6nh=5;

m8d=7.8+0.3;
m8dh=m8d-0.1;
m8nd=14.5+0.3;
m8nh=6.5;



sbd = 8+0.3;
sbr = sbd/2;

iy=30.5-1.8-6.5;


hz=70;
hy=20;
hs=50;

td=m6d;		// !!!
tnd=m6nd;	// !!!
tnh=m6nh;	// !!!

dz=30; 		// beetween smooth and thread rod

bearing_diameter=15; 

thinwall = 2;
bearing_size = bearing_diameter + 2 * thinwall;

hx=dz+tnd/2+bearing_size/2+2;

//mirror([0,1,0])
{
difference() {
	union() {
		translate([0,0,hz/2]) cube([hx, hy, hz], center=true);
		translate([-hx/2+bearing_size/2, -15, 0]) cylinder(h = hz, r=bearing_size/2, $fn = 64);
		translate([-hx/2, -15, 0]) cube([bearing_size, bearing_size/2, hz]);
		translate([-hx/2+bearing_size/2, -hy/2-(td+4), hz/2-(tnh+4)/2]) cube([hx-bearing_size/2, td+4, tnh+4]);

		%translate([-hx/2-43, hy/2, (hz-43)/2]) cube([43,43,43]);
		%translate([-hx/2-(43-31)/2, hy/2+5, (hz-31)/2]) rotate([90,0,0]) cylinder(10, m3r, m3r, $fn=8);
		%translate([-hx/2-(43-31)/2-31, hy/2+5, (hz-31)/2]) rotate([90,0,0]) cylinder(10, m3r, m3r, $fn=8);
		%translate([-hx/2-(43-31)/2-31, hy/2+5, (hz-31)/2+31]) rotate([90,0,0]) cylinder(10, m3r, m3r, $fn=8);
		%translate([-hx/2-(43-31)/2, hy/2+5, (hz-31)/2+31]) rotate([90,0,0]) cylinder(10, m3r, m3r, $fn=8);
		%translate([-hx/2-43/2, hy/2+5, hz/2]) rotate([90,0,0]) cylinder(10, 22/2, 22/2);
		translate([-hx/2-43/2+23/2-4, -hy/2, 0]) cube([(43-23)/2+4, hy, hz]);
		translate([-hx/2-43-2, -hy/2, 0]) cube([43, hy, hz/2-23/2+1]);
		translate([-hx/2-43/2+23/2-8, -hy/2, hz/2-12]) cube([10,hy,10]);
	} //union


	translate([-hx/2+bearing_size/2, -15, -1]) cylinder(h = hz+2, r=bearing_diameter/2, $fn = 64);
	translate([-hx/2+bearing_size/2,-15,-1]) rotate([0,0,-150])  cube([10,1,hz+2]);


	translate([-hx/2+bearing_size/2+dz, -15, hz/2-tnh/2]) rotate([0,0,30]) cylinder(tnh, tnd/2, tnd/2, $fn=6);
	translate([-hx/2+bearing_size/2+dz, -15-4, hz/2-tnh/2]) rotate([0,0,30]) cylinder(tnh, tnd/2, tnd/2, $fn=6);

	translate([-hx/2+bearing_size/2+dz, -15, hz/2+tnh/2+0.2]) cylinder(4, (td+0.4)/2, (td+0.4)/2);
	translate([-hx/2+bearing_size/2+dz, -15, hz/2-(tnh+4)/2+0.2]) cylinder((tnh+4)/2, (td+0.4)/2, (td+0.4)/2);



	translate([-hx/2-1, 0, (hz-hs)/2]) rotate([0,90,0]) cylinder(hx+2, sbr, sbr, $fn=16);
	translate([-hx/2-1, 0, (hz-hs)/2+2.3]) rotate([0,90,0]) rotate([0,0,180]) cylinder(hx+2, sbd/3, sbd/3, $fn=5);
	translate([-hx/2-1, 0, (hz-hs)/2+hs]) rotate([0,90,0]) cylinder(hx+2, sbr, sbr, $fn=16);
	translate([-hx/2-1, 0, (hz-hs)/2+hs+2.3]) rotate([0,90,0]) rotate([0,0,180]) cylinder(hx+2, sbd/3, sbd/3, $fn=5
);

	translate([-hx/2-43/2, -10/2, hz/2-(23)/2]) cube([hx+43/2+1,10, 23]);


      for (i=[0:3]) {
		translate([-hx/2-43/2-i, -hy/2-1, hz/2]) rotate([-90,0,0]) cylinder(hy+2, 23/2, 23/2, $fn=32);

		translate([-hx/2-(43-31)/2-i, -hy/2-1, (hz-31)/2]) rotate([-90,0,0]) rotate([0,0,45/2]) cylinder(hy+2, m3r+0.1, m3r+0.1, $fn=8);
		translate([-hx/2-(43-31)/2-31-i, -hy/2-1, (hz-31)/2]) rotate([-90,0,0]) rotate([0,0,45/2]) cylinder(hy+2, m3r+0.1, m3r+0.1, $fn=8);
		translate([-hx/2-(43-31)/2-i, -hy/2-1, (hz-31)/2+31]) rotate([-90,0,0]) rotate([0,0,45/2]) cylinder(hy+2, m3r+0.1, m3r+0.1, $fn=8);

		translate([-hx/2-(43-31)/2-i, -hy/2-1, (hz-31)/2]) rotate([-90,0,0]) rotate([0,0,360/16/2]) cylinder(hy-15.5+4+1, 3.8, 3.8, $fn=16);
		translate([-hx/2-(43-31)/2-31-i, -hy/2-1, (hz-31)/2]) rotate([-90,0,0]) rotate([0,0,360/16/2]) cylinder(hy-15.5+4+1, 3.8, 3.8, $fn=16);
		translate([-hx/2-(43-31)/2-i, -hy/2-1, (hz-31)/2+31]) rotate([-90,0,0]) rotate([0,0,360/16/2]) cylinder(hy-15.5+4+1, 3.8, 3.8, $fn=16);
	}

	translate([-hx/2-43-20,-hy/2-1,0]) rotate([0,45,0]) cube([20,30,20]);
	translate([-hx/2-36,-hy/2-1,hz]) rotate([0,45,0]) cube([20,30,20]);


//	translate([-50, -50, -1]) cube([100,100,100]);
//	translate([-65, -50, -1]) cube([100,100,8]);
} //  difference


difference() {
  translate([-hx/2+bearing_size/2+10, -hy/2-(td+4), 0]) cube([hx-bearing_size/2-10, (td+4)-0.5, hz/2-(tnh+4)/2-0.4]);
  translate([-hx/2+bearing_size/2+10+1-0.1, -hy/2-(td+4)+1-0.1, 0]) cube([hx-bearing_size/2-10-2+0.2, (td+4)-0.5-2+0.2, hz/2-(tnh+4)/2-0.4-1]);
}


translate([-hx/2-(43-31)/2-0.6, 0, (hz-31)/2])  cube([0.4, 20, 8], center=true);
translate([-hx/2-(43-31)/2-2.4, 0, (hz-31)/2])  cube([0.4, 20, 8], center=true);
translate([-hx/2-(43-31)/2-31-0.6, 0, (hz-31)/2])  cube([0.4, 20, 8], center=true);
translate([-hx/2-(43-31)/2-31-2.4, 0, (hz-31)/2])  cube([0.4, 20, 8], center=true);
translate([-hx/2-(43-31)/2-0.6, 0, (hz-31)/2+31])  cube([0.4, 20, 8], center=true);
translate([-hx/2-(43-31)/2-2.4, 0, (hz-31)/2+31])  cube([0.4, 20, 8], center=true);

translate([-7, -2, hz/2]) cube([hx+43/2-8, 0.4, 23], center=true);
translate([-7, +2, hz/2]) cube([hx+43/2-8, 0.4, 23], center=true);

} // mirr