
m3d=3+0.4;
m3r=m3d/2;

m4d=4+0.4;
m4r=m4d/2;

m5d=5+0.4;
m5r=m5d/2;

m3nd = 6.2+0.4;
m3nr = m3nd/2;
m3nh=2.8;

m5nd = 9+0.4;
m5nr = m5nd/2;
m5nh=4.2;

sbd = 8+0.3;
sbr = sbd/2;

hs=50;
bh=25;

hz=11;

hx=bh+bh+2+2;
hy=hs+15+6+6;

bd=15.1;

gt2_22d=11.9;
t25_16d=10.7;

id_dia=13;
pl_dia=gt2_22d;
//pl_dia=15.6;


belth=1.4;
st=2;

ky=2;
kx=0;
kxd=5;
kh=40;

module ziptie(d) {
  difference() {
  cylinder(3, (d+4)/2,(d+4)/2,$fn=64, center=true);
  cylinder(3, d/2,d/2,$fn=64, center=true);
  }
}

rotate([0,90,0])
difference() {
  union() {

	  translate([0,-4,-hz/2-1]) cube([hx, hy, hz], center=true);
	  translate([0,3,0]) cube([hx, 19, 8], center=true);
	  translate([-hx/2, hs/2, 0]) rotate([0, 90, 0]) cylinder(hx, (bd+4)/2, (bd+4)/2, $fn=64);
	  translate([-hx/2, -hs/2, 0]) rotate([0, 90, 0]) cylinder(hx, (bd+4)/2, (bd+4)/2, $fn=64);
  } // union

  translate([-hx/2-1, hs/2, 0]) rotate([0, 90, 0]) cylinder(hx+2, bd/2, bd/2, $fn=64);

  translate([-hx/2-1, -hs/2, 0]) rotate([0, 90, 0]) cylinder(hx+2, bd/2, bd/2, $fn=64);

	translate([0, hs/2, 5]) cube([hx+1, 8.4, 10], center=true);
	translate([0, -hs/2, 5]) cube([hx+1, 8.4, 10], center=true);



  translate([-5, id_dia/2+0.8-16, -5]) cube([10, 18, 10]);
  translate([0, 12, 4.5]) rotate([-60, 0, 0]) cube([hx+2, 9, 2], center=true);

  translate([-hx/2-1, 12.5, -5]) cube([hx+2, 3.1, 10+1]);




  translate([0, pl_dia/2+belth/2, -4]) cube([hx/2+1, belth/2, 8.2]);
  for (i=[0:st:hx/2]) {
    translate([i, pl_dia/2, -4]) cube([st/2, belth/2-0.4, 8+1]);  
    translate([i, pl_dia/2, -4]) cube([0.2, belth/2+0.1, 8+1]);  
    translate([i+st/2-0.2, pl_dia/2, -4]) cube([0.2, belth/2+0.1, 8+1]);  
    translate([i, pl_dia/2, -4]) cube([st/2, belth/2+0.1, 0.4]);  
	}

  translate([-hx/2, id_dia/2+belth/2, -4]) cube([hx/2+1, belth/2, 8.2]);
  for (i=[-hx/2:st:0]) {
    translate([i, id_dia/2, -4]) cube([st/2, belth/2-0.4, 8+1]);  
    translate([i, id_dia/2, -4]) cube([0.2, belth/2+0.1, 8+1]);  
    translate([i+st/2-0.2, id_dia/2, -4]) cube([0.2, belth/2+0.1, 8+1]);  
    translate([i, id_dia/2, -4]) cube([st/2, belth/2+0.1, 0.4]);  
	}






  translate([-hx/2-1, -5, 1.5]) rotate([60, 0, 0]) cube([hx+2, 3, 1]);

  translate([-hx/2-1, -id_dia/2-9.1, -5]) cube([hx+2, 11, 10+1]);

  translate([-hx/2-1, -2, -5]) cube([hx+2, 2, 10+1]);

  translate([-bh/2+kx, ky, -hz-2]) cylinder(hz+7, m3r, m3r, $fn=8);
  translate([bh/2+kx, ky, -hz-2]) cylinder(hz+7, m3r, m3r, $fn=8);
  translate([-bh/2+kxd, ky-kh, -hz-2]) cylinder(hz+7, m3r, m3r, $fn=8);
  translate([bh/2+kxd, ky-kh, -hz-2]) cylinder(hz+7, m3r, m3r, $fn=8);

  translate([-bh/2+kx, ky, -hz-1+6]) cylinder(hz+7, 3.8, 3.8, $fn=16);
  translate([bh/2+kx, ky, -hz-1+6]) cylinder(hz+7, 3.8, 3.8, $fn=16);
  translate([-bh/2+kxd, ky-kh, -hz-1+7]) cylinder(hz+7, 3.8, 3.8, $fn=16);
  translate([bh/2+kxd, ky-kh, -hz-1+7]) cylinder(hz+7, 3.8, 3.8, $fn=16);


//  translate([-hx/2, hy/2+2, -6]) rotate([0,0,45]) cube([10,10,hz+7], center=true);
//  translate([hx/2, hy/2+2, -6]) rotate([0,0,45]) cube([10,10,hz+7], center=true);
  translate([-hx/2-1, -hy/2-4, -6]) rotate([0,0,45]) cube([10,10,hz+7], center=true);
  translate([hx/2+1, -hy/2-4, -6]) rotate([0,0,45]) cube([10,10,hz+7], center=true);

}

translate([-4.5, id_dia/2+0.8-12, -4.6]) cube([8.5, 13.6, 9.2]);


